package xyz.veronie.bgg.data;


import javax.inject.Inject;

import org.eclipse.e4.core.di.annotations.Optional;
import org.eclipse.e4.ui.di.UIEventTopic;

public class ResultConfigManager {

	private ResultConfig resultConfig = new ResultConfig();

	@Inject
	@Optional
	private void subscribeTopicSourceFilterChanged
	    (@UIEventTopic(EventConstants.TOPIC_FILTER_CHANGED)
	        SourceFilter source) {
	    getResultConfig().source = source;
	}
	
	@Inject
	@Optional
	private void subscribeTopicSubtypesChanged
	    (@UIEventTopic(EventConstants.TOPIC_SUBTYPE_CHANGED)
	        Subtype subtype, Boolean checked) {
	    getResultConfig().subTypes.put(subtype, checked);
	}
	
	@Inject
	@Optional
	private void subscribeTopicUserChanged
	    (@UIEventTopic(EventConstants.TOPIC_USER_CHANGED)
	        String user) {
		System.out.println("set user to '" + user + "'");
	    getResultConfig().user = user;
	}
	
	@Inject
	@Optional
	private void subscribeTopicUserFlagChanged
	    (@UIEventTopic(EventConstants.TOPIC_USERFLAG_CHANGED)
	        UserFlag flag, FilterFlagState state) {
	    getResultConfig().userFlags.put(flag, state);
	}
	
	@Inject
	@Optional
	private void subscribeTopicResultActionChanged
	    (@UIEventTopic(EventConstants.TOPIC_ACTION_CHANGED)
	        ResultAction action) {
	    getResultConfig().action = action;
	}

	public ResultConfig getResultConfig() {
		return resultConfig;
	}

	
}
